function LootSquid:RegisterEvents()

    -- hook chat events
    LootSquid:RegisterEvent("CHAT_MSG_BN_WHISPER", "OnChatMessage")
    LootSquid:RegisterEvent("CHAT_MSG_RAID", "OnChatMessage")
    LootSquid:RegisterEvent("CHAT_MSG_WHISPER", "OnChatMessage")
    LootSquid:RegisterEvent("CHAT_MSG_GUILD", "OnChatMessage")
    LootSquid:RegisterEvent("CHAT_MSG_PARTY", "OnChatMessage")

    -- hook loot events
    LootSquid:RegisterEvent("LOOT_OPENED", "OnLootOpened")
    LootSquid:RegisterEvent("LOOT_CLOSED", "OnLootClosed")
end

function LootSquid:OnChatMessage(event, message, sender, language, channelString, target, flags,
unknown, channelNumber, channelName, unknown, counter, guid)
    LootSquid:Print("Received message: " .. message .. " from: " .. sender)

    -- if loot dist in session...

    local isNeed = LootSquid:strStartsWith(message, "!need")
    local isGreed = LootSquid:strStartsWith(message, "!greed")

    if (_G["LootSquidSession"].currentLootSlot < 1 and (isNeed or isGreed)) then
        SendChatMessage("LootSquid: The loot master does not currently have an active loot session",
            "WHISPER",
            nil,
            sender)
        return
    end


    if (isNeed) then

        _G["LootSquidSession"].playersNeeding[sender] = true
        LootSquid:UpdateRequestFrame()

        SendChatMessage("LootSquid: Your need request have been received. Please wait.",
            "WHISPER",
            nil,
            sender)
    end

    if (isGreed) then

        _G["LootSquidSession"].playersGreeding[sender] = true
        LootSquid:UpdateRequestFrame()

        SendChatMessage("LootSquid: Your greed request have been received. Please wait.",
            "WHISPER",
            nil,
            sender)
    end
end

function LootSquid:OnLootOpened(autoLoot)


    local method, partyMaster, raidMaster = GetLootMethod()
    local playerName, playerRealm = UnitName("player")

    LootSquid:Print("Loot opened. Method: " .. method .. ", partyMaster: " .. tostring(partyMaster) .. ", raidMaster: " .. tostring(raidMaster))


    for k in pairs(_G["LootSquidSession"].loot) do
        _G["LootSquidSession"].loot[k] = nil
    end


    --self:BuildLootGui()

    -- if player is the master looter
    if (method == "master" and partyMaster == 0) then
        LootSquid:Print("I am the master looter ...")

        _G["LootSquidSession"].lootSlots = GetNumLootItems()

        for lootSlot = 1, GetNumLootItems() do
            LootSquid:Print("Processing lootSlot " .. lootSlot)

            local _, itemName, _, _, _ = GetLootSlotInfo(lootSlot)
            LootSquid:Print("after GetLootSlotInfo " .. itemName)

            local itemLink = GetLootSlotLink(lootSlot)
            LootSquid:Print(tostring(itemName) .. ", link: " .. tostring(itemLink))

            _G["LootSquidSession"].loot[lootSlot] = { itemName = itemName, itemLink = itemLink, candidates = {} }

            for candidateIndex = 1, 40 do
                --LootSquid:Print("Processing candidateIndex "..candidateIndex)

                local candidateName = GetMasterLootCandidate(lootSlot, candidateIndex)
                if candidateName then
                    --LootSquid:Print(lootSlot.." -> "..candidateName)

                    _G["LootSquidSession"].loot[lootSlot].candidates[candidateName] = {
                        candidateIndex = candidateIndex,
                    }

                    --                    lss.candidates[candidateName] = {
                    --                        candidateIndex = candidateIndex,
                    --                    }

                    -- test: give it to me
                    --                    if( candidateName == UnitName("player")) then
                    --                        --GiveMasterLoot(lootSlot, candidateIndex)
                    --                        LootSquid:Print("Loot "..itemName.." given to: "..candidateName)
                    --                    end



                else
                    --LootSquid:Print("no candidate name")
                end
            end
        end

        self:BuildLootGui()
    end
end

function LootSquid:OnLootClosed()
end
